/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.5.A, Date: 28-Aug-2008.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "fpml-main-4-4.h"

int main (int argc, char** argv)
{
   Document_derivations* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE;
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;
   const OSOCTET* pMsgBuf;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-o")) filename = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-notrace")) trace = FALSE;
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: writer [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Populate structure of generated type */

   pdata = Test_FpML (&ctxt);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_FpML (&ctxt, pdata);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

      stat = rtXmlWriteToFile (&ctxt, filename);
   }
   else if (trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}
