/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.2.A, Date: 12-Sep-2010.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "test.h"
#include "rtxsrc/rtxMemLeakCheck.h"
#include "rtxsrc/rtxStreamFile.h"
#include "rtxsrc/rtxPrint.h"
#include "rtxsrc/rtxDiag.h"

int main (int argc, char** argv)
{
   SmallSizeType* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  jsonfname = "message.json";
   OSBOOL       trace = TRUE;
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-o")) jsonfname = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-notrace")) trace = FALSE;
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: writer [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtxInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Populate structure of generated type */

   pdata = Test_smallSize (&ctxt);

   /* Encode JSON */

   stat = rtxStreamFileCreateWriter (&ctxt, jsonfname);

   if (0 == stat) {
      stat = JsonEnc_smallSize (&ctxt, pdata);
   }
   rtxStreamClose (&ctxt);

   if (0 == stat) {
      if (trace) {
         printf ("encoded message:\n");
         rtxPrintFile (jsonfname);
         printf ("\n");
      }
   }
   else {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);

   return stat;
}
