/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.3.0, Date: 23-Jan-2008.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxSOAP.h"
#include "rtxsrc/rtxSocket.h"
#include "rtxmlsrc/rtXmlCppMsgBuf.h"
#include "rtxsrc/OSRTMemoryInputStream.h"
#include "rtxsrc/rtxStreamSocket.h"
#include "StockQuoteWSDL.h"

#define DEFAULT_URL "http://127.0.0.1:9123"

int main (int argc, char** argv)
{
   OSXMLEncodeBuffer buffer;
   OSCTXT*           pctxt;
   OSOCTET*          ptmpbuf = 0;
   OSSOAPCONN        soapConn;
   const char*       url = DEFAULT_URL;
   int               i, stat;
   OSBOOL            verbose = FALSE, trace = TRUE;

   // Process command line arguments

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-url")) {
            url = argv[++i];
         }
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: client [-v] [-url <url>] [-notrace]\n");
            printf ("   -v    verbose mode: print trace info\n");
            printf ("   -url  connect to <url>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   // Get context pointer

   pctxt = buffer.getCtxtPtr();
   buffer.setDiag (verbose);

   // One-time socket package initialization (required for Windows only)

   stat = rtxSocketsInit();
   if (0 != stat) {
      printf ("Socket initialization failed.\n");
      rtxErrSetData (pctxt, stat, __FILE__, __LINE__);
      buffer.printErrorInfo();
      return stat;
   }

   // Populate structure of generated type


   GetLastTradePrice_Input value;
   GetLastTradePrice_Input_CC pdu(buffer, value);

   value.TradePriceRequest.tickerSymbol.setValue ((const OSUTF8CHAR*)"DIS");

   // Encode

   stat = pdu.encode();

   if (0 != stat) {
      printf ("Encoding failed\n");
      buffer.printErrorInfo();
      return stat;
   }

   // Connect to server

   rtxSoapInitConn (&soapConn, pctxt, OSSOAPV1, url);

   stat = rtxSoapConnect (&soapConn);
   if (stat != 0) {
      buffer.printErrorInfo();
      return stat;
   }
   if (trace) printf ("Connection to web service opened\n");

   // Send request

   soapConn.soapAction = "test#GetLastTradePrice";

   stat = rtxSoapSendHttp (&soapConn, buffer.getMsgPtr());
   if (stat != 0) {
      buffer.printErrorInfo();
      return stat;
   }
   if (trace) printf ("HTTP request sent\n");

   // Wait for response

   stat = rtxSoapRecvHttp (&soapConn);
   if (stat != 0) {
      buffer.printErrorInfo();
      rtxStreamClose (pctxt);
      return stat;
   }
   if (trace) printf ("HTTP response received\n");

   // Read HTTP response into memory

   stat = rtxSoapRecvHttpContent (&soapConn, &ptmpbuf);
   if (stat != 0) {
      buffer.printErrorInfo();
      return stat;
   }

   // Close connection

   rtxStreamClose (pctxt);

   // Decode SOAP XML message

   OSRTMemoryInputStream in (ptmpbuf, soapConn.contentLength);
   OSXMLDecodeBuffer decodeBuffer (in);

   if (decodeBuffer.getStatus ()) {
      decodeBuffer.printErrorInfo();
      return decodeBuffer.getStatus ();
   }

   decodeBuffer.setDiag (verbose);

   GetLastTradePrice_Output* pOutValue = 0;
   GetLastTradePrice_Output_CC pdu_out (decodeBuffer, pOutValue);

   stat = pdu_out.decode();

   if (0 == stat) {
      if (trace) {
         printf ("Decoding was successful\n");
         printf ("Decoded record:\n");
         pdu_out.print ("GetLastTradePrice_Output");
         printf ("\n");
      }
   }
   else if (RTERR_SOAPFAULT == stat) {
      if (trace) {
         printf ("Decoding was successful\n");
         printf ("Decoded record:\n");
         pdu_out.print ("GetLastTradePrice_Fault");
         printf ("\n");
      }
   }
   else if (trace) {
      printf ("Decoding failed\n");
      decodeBuffer.printErrorInfo ();
   }

   rtxFreeContext (pctxt);

   return stat;
}

