/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.1.0, Date: 18-Feb-2005.
 * Copyright (c) 2003-2006 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxmlsrc/OSXMLEncodeBuffer.h"
#include "client.h"

int main (int argc, char** argv)
{
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;
   const OSOCTET* msgptr;

   // Process command line arguments

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   // Create buffer and control objects

   XMPPC_message_ELEM msgdata;
   OSXMLEncodeBuffer buffer;
   XMPPC_message_CC pdu (buffer, msgdata);

   buffer.setDiag (verbose);

   // Populate structure of generated type

   { XMPPC_message_ELEM_1* pdata0;
   pdata0 = new XMPPC_message_ELEM_1();
   pdata0->t = 2;
   pdata0->u.XMPPC_body = new XMPPC_body_ELEM();   
   pdata0->u.XMPPC_body->value.setValue(
      (OSUTF8CHAR*) "Art thou not Romeo, and a Montague?");
   msgdata._choice1.append (pdata0);
   }

   msgdata.From.setValue((const OSUTF8CHAR*) "juliet@example.com");
   msgdata.m.FromPresent = 1;
   msgdata.To.setValue((const OSUTF8CHAR*) "romeo@example.com");
   msgdata.m.ToPresent = 1;
   msgdata.Lang.setValue((const OSUTF8CHAR*) "en");
   msgdata.m.LangPresent = 1;

   // Encode

   stat = pdu.encode();

   if (0 == stat) {
      if (trace) {
         msgptr = buffer.getMsgPtr();
         printf ("encoded XML message:\n");
         puts ((char*)msgptr);
         printf ("\n");
      }

      // Write the encoded message out to the output file

      buffer.write (filename);
   }
   else {
      printf ("Encoding failed\n");
      buffer.printErrorInfo();
      return stat;
   }

   return 0;
}
