/*
 * Copyright (c) 2017 Objective Systems, Inc.
 *
 * See the COPYING.txt file in this subdirectory for conditions on use
 * of this software.  This notice applies to software only in this
 * subdirectory (oortsrc) and not to other software that may be a
 * a part of this distribution.
 *
 *****************************************************************************/
/**
 * @file ooTime.h
 * Time functions that reconcile differences between Windows and UNIX.
 */
#ifndef _OOTIME_H_
#define _OOTIME_H_

#include "oortsrc/ooCommon.h"
#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * This function provides an abstraction for the UNIX 'gettimeofday'
 * function which is not available on Windows.
 *
 * @param tv           Pointer to time value structure to receive
 *                     current time value.
 * @param tz           Point to time zone information.
 * @return             Completion status of operation: 0 = success,
 *                     negative return value is error.
 */
EXTERN int ooGetTimeOfDay (struct timeval *tv, struct timezone *tz);

#ifdef __cplusplus
}
#endif
#endif
